<%-- $Id: index.jsp 4510 2008-09-11 20:03:48Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!
	private static final ItemContext defaultContext = 
		Base.createDefaultContext("name", "name,quota,diskUsage");
	private static final Item itemType = Item.DISKUSAGE;
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
String subContext = request.getParameter("subcontext");
final String overviewPage = "overview.jsp?ID="+ID;
final String listUsersPage = "list_users.jsp?ID="+ID;
final String listGroupsPage = "list_groups.jsp?ID="+ID;
final String viewUserPage = "view_user.jsp?ID="+ID;
final String viewGroupPage = "view_group.jsp?ID="+ID;

String forward = null;
String redirect = null;
String message = null;
DbControl dc = null;

try
{
	if (cmd == null || "Overview".equals(cmd))
	{
		// Display the list page without updatinging the current context
		Base.getAndSetCurrentContext(sc, itemType, null, null, true);
		redirect = overviewPage;
	}
	else if ("ListUsers".equals(cmd))
	{
		Base.getAndSetCurrentContext(sc, itemType, "perUser", (PageContext)null, defaultContext, true);
		redirect = listUsersPage;
	}
	else if ("ListGroups".equals(cmd))
	{
		Base.getAndSetCurrentContext(sc, itemType, "perGroup", (PageContext)null, defaultContext, true);
		redirect = listGroupsPage;
	}
	else if ("UpdateContext".equals(cmd))
	{
		// Display the list page after updating the current context from the request parameters
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, subContext, pageContext, defaultContext);
		String ss = request.getParameter("showStatistics");
		if (ss != null) cc.setSetting("showStatistics", ss);
		redirect = "perUser".equals(subContext) ? listUsersPage : "perGroup".equals(subContext) ? listGroupsPage : overviewPage;
	}
	else if ("LoadContext".equals(cmd))
	{
		// Display the list page after loading a saved context
		int contextId = Values.getInt(request.getParameter("context"));
		Base.loadContext(sc, contextId, defaultContext);
		redirect = "perUser".equals(subContext) ? listUsersPage : "perGroup".equals(subContext) ? listGroupsPage : overviewPage;
	}
	else if ("ViewUser".equals(cmd))
	{
		// Display the view page for a single item 
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, "perUser", pageContext, defaultContext);
		forward = viewUserPage;
	}
	else if ("ViewGroup".equals(cmd))
	{
		// Display the view page for a single item 
		ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, "perGroup", pageContext, defaultContext);
		forward = viewGroupPage;
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
finally
{
	if (dc != null) dc.close();
}

if (forward != null)
{
	pageContext.forward(forward);
}
else if (redirect != null)
{
	response.sendRedirect(redirect);
}
else if (message == null)
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&wait=0");
}
else
{
	response.sendRedirect(root + "common/close_popup.jsp?refresh_opener=1&message="+HTML.urlEncode(message));
}
%>

