<%-- $Id: finish_job.jsp 4537 2008-09-18 09:23:28Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PluginConfiguration"
	import="net.sf.basedb.core.PluginType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.JobAgent"
	import="net.sf.basedb.core.PluginResponse"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.plugin.Response"
	import="net.sf.basedb.core.plugin.InteractivePlugin"
	import="net.sf.basedb.core.plugin.AutoDetectingImporter"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.Set"
	import="java.util.Map"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
try
{
	Job job = (Job)sc.getSessionSetting("plugin.configure.job");
	dc.reattachItem(job);
	PluginDefinition plugin = job.getPluginDefinition();
	PluginConfiguration pluginConfig = job.getPluginConfiguration();
	boolean sendMessage = Values.getBoolean(sc.getUserClientSetting("plugins.sendmessage"), true);
	boolean removeJobWhenFinished = Values.getBoolean(sc.getUserClientSetting("plugins.removejob"), false);

	PluginResponse pluginResponse = (PluginResponse)sc.getSessionSetting("plugin.configure.response");
	boolean executeImmediately =
		pluginResponse != null && pluginResponse.getStatus() == Response.Status.EXECUTE_IMMEDIATELY;

	List<JobAgent> agents = null;
	if (!executeImmediately && sc.hasSystemPermission(Permission.SELECT_JOBAGENT))
	{
		ItemQuery<JobAgent> agentQuery = JobAgent.getQuery();
		agentQuery.join(Hql.innerJoin("plugins", "plg"));
		agentQuery.restrict(Restrictions.eq(Hql.index("plg", null), Hql.entity(plugin)));
		agentQuery.include(Include.ALL);
		agentQuery.order(Orders.asc(Hql.property("name")));
		agents = agentQuery.list(dc);
	}
	%>
	<base:page type="popup" title="Set job name and options">
	<base:head scripts="plugin.js">
		<script language="JavaScript">
		function doFinish()
		{
			var frm = document.forms['plugin'];
			if (Main.trimString(frm.name.value) == '')
			{
				frm.name.focus();
				alert('You must enter a name for the job');
				return false;
			}
			frm.submit();
		}
		function doCancel()
		{
			location = 'index.jsp?ID=<%=ID%>&cmd=CancelWizard';
		}
		</script>
	</base:head>
	<base:body>
		<form name="plugin" action="index.jsp" method="post" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="FinishNewJob">

		<h3 class="docked">Set job name and options <base:help helpid="runplugin.finishjob" /></h3>
		<div class="boxed">
			<table class="form" width="100%">
			<tr valign="top">
				<td class="prompt">Plugin</td>
				<td><%=HTML.encodeTags(plugin.getName())%></td>
			</tr>
			<tr valign="top" id="configurations">
				<td class="prompt">Configuration</td>
				<td><%=pluginConfig == null ? "<i>- none -</i>" : HTML.encodeTags(pluginConfig.getName())%></td>
			</tr>

			<tr valign="top">
				<td class="prompt">Job name</td>
				<td><input type="text" class="text required" 
					name="name" value="<%=HTML.encodeTags(job.getName())%>" 
					size="40" maxlength="<%=Job.MAX_NAME_LENGTH%>">
				</td>
			</tr>
			
			<%
			if (agents != null && agents.size() > 0)
			{
				%>
				<tr valign="top">
					<td class="prompt">Use job agent</td>
					<td>
						<select name="agent_id">
						<option value="">- automatic -
						<%
						for (JobAgent agent : agents)
						{
							%>
							<option value="<%=agent.getId()%>"><%=HTML.encodeTags(agent.getName())%>
							<%
						}
						%>
						</select>
					</td>
				</tr>
				<%
			}
			%>
			
			<tr valign="top">
				<td class="prompt">Job description</td>
				<td nowrap>
					<textarea class="text" rows="4" cols="40" name="job_description" wrap="virtual"
						><%=HTML.encodeTags(job.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Job description', 'plugin', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			
			<tr>
				<td class="prompt">Send message</td>
				<td>
					<input type="checkbox" name="send_message" value="1" <%=sendMessage ? "checked" : "" %>>
					<a href="javascript:document.forms['plugin'].send_message.click();">Send a message when the job is completed</a>
				</td>
			</tr>
			
			<tr>
				<td class="prompt">Remove job</td>
				<%
				if (plugin.getMainType().equals(Plugin.MainType.EXPORT) || 
						plugin.getMainType().equals(Plugin.MainType.IMPORT))
				{
					%>
					<td>
						<input type="checkbox" name="remove_job" value="1" <%=removeJobWhenFinished ? "checked" : "" %>>
						<a href="javascript:document.forms['plugin'].remove_job.click();">Remove job when finished</a>
					</td>
					<%
				}
				else
				{
					%>
					<td><i>- n/a -</i></td>
					<%
				}
				%>
			</tr>
						
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</div>
		</form>
	
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="doFinish();" title="Finish" image="gonext.gif" /></td>
			<td width="50%"><base:button onclick="doCancel();" title="Cancel" /></td>
		</tr>
		</table>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

