<%-- $Id: select.jsp 4570 2008-10-08 12:35:03Z martin $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.FileType"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Quota"
	import="net.sf.basedb.core.QuotaType"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.zip.FileUnpacker"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.nio.charset.Charset"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.FILE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	File file = null;
	Directory directory = null;
	boolean readCurrentFileType = true;
	int currentFileTypeId = 0;
	Boolean compress = Application.autoCompressionEnabled() ? null : false; // null == auto

	if (itemId == 0)
	{
		title = "Upload new file";
		currentFileTypeId = Values.getInt(cc.getPropertyValue("fileType"), 0);
		if (currentFileTypeId == 0)
		{
			currentFileTypeId = Values.getInt(cc.getRecent(Item.FILETYPE.name(), 0), 0);
		}
		directory = Directory.getById(dc, Values.getInt(request.getParameter("directory_id"), SystemItems.getId(Directory.ROOT)));
		cc.removeObject("item");
		if (directory.getAutoCompress()) compress = true;
	}
	else
	{
		file = File.getById(dc, itemId);
		directory = file.getDirectory();
		cc.setObject("item", file);
		title = "Upload again -- " + HTML.encodeTags(file.getName());
		try
		{
			FileType ft = file.getFileType();
			if (ft != null) currentFileTypeId = ft.getId();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentFileType = false;
		}
	}
	if (file != null && !file.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	
	if (file == null || file.getLocation() != Location.PRIMARY)
	{
		// Check quota
		User user = User.getById(dc, sc.getLoggedInUserId());
		QuotaType totalQuotaType = QuotaType.getById(dc, SystemItems.getId(QuotaType.TOTAL));
		QuotaType fileQuotaType = QuotaType.getById(dc, SystemItems.getId(QuotaType.FILE));
		
		if (user.hasExceededQuota(totalQuotaType, Location.PRIMARY) 
			|| user.hasExceededQuota(fileQuotaType, Location.PRIMARY))
		{
			throw new PermissionDeniedException("Quota has been exceeded");
		}
	}
	
	
	// Query to retrieve file types
	final ItemQuery<FileType> fileTypeQuery = FileType.getQuery();
	fileTypeQuery.order(Orders.asc(Hql.property("name")));
	fileTypeQuery.setCacheResult(true);
	
	// Query to retreive FileUnpacker plugins
	final ItemQuery<PluginDefinition> pluginQuery = PluginDefinition.getQuery(null, "net.sf.basedb.util.zip.FileUnpacker");
	pluginQuery.order(Orders.asc(Hql.property("name")));
	pluginQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
	List<PluginDefinition> plugins = pluginQuery.list(dc);

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,ajax.js" styles="tabcontrol.css,progressbar.css">
		<script language="JavaScript">
		// Validate the "File" tab
		function validateFile()
		{
			var frm = document.forms['file'];
			if (Main.trimString(frm.the_file.value) == '')
			{
				alert("You must select a file to upload");
				frm.the_file.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function doUpload()
		{
			var frm = document.forms['file'];
			if (TabControl.validateActiveTab('settings'))
			{
				// Copy form values so they are sent BEFORE the file
				frm.check_md5.value = frm.temp_check_md5 && frm.temp_check_md5.checked ? "1" : "0";
				frm.write_protected.value = frm.temp_write_protected.checked ? "1" : "0";
				<%
				if (file == null)
				{
					%>
					frm.replace_existing.value = frm.temp_replace_existing.checked ? "1" : "0";
					<%
				}
				%>
				frm.compressed.value = frm.temp_compressed && frm.temp_compressed[frm.temp_compressed.selectedIndex].value;
				if (frm.temp_zip_format)
				{
					frm.zip_format.value = frm.temp_zip_format[frm.temp_zip_format.selectedIndex].value;
					frm.zip_unpack.value = frm.temp_zip_unpack.checked ? "1" : "0";
					frm.zip_overwrite.value = frm.temp_zip_overwrite.checked ? "1" : "0";
					frm.zip_keep.value = frm.temp_zip_keep.checked ? "1" : "0";
				}
				frm.characterSet.value = frm.temp_charset[frm.temp_charset.selectedIndex].value;
				frm.filetype_id.value = frm.temp_filetype_id[frm.temp_filetype_id.selectedIndex].value;
				frm.description.value = frm.temp_description.value;
				frm.submit();
				Main.hide('selectForm');
				Main.show('progressForm');
				if (!sendProgressUpdateWithAjax())
				{
					window.top.frames['progress'].location.href = 'progress.jsp?ID=<%=ID%>';
				}
			}
		}
		
		function sendProgressUpdateWithAjax()
		{
			var request = Ajax.getXmlHttpRequest();
			if (request != null)
			{
				var url = 'progress.jsp?ID=<%=ID%>&ajax=1&'+Math.random();
				request.open("GET", url, true);
				Ajax.setReadyStateHandler(request, updateProgressWithAjax);
				request.send(null);
			}
			return request != null;
		}
		
		function updateProgressWithAjax(request)
		{
			var response = request.responseText.split(':');
			//alert(response[0]+':'+response[1]+':'+response[2]+':'+response[3]+':'+response[4]+':'+response[5]);
			displayProgress(response[0],response[1],response[2],response[3],response[4],response.slice(5).join(':'));
			setTimeout('sendProgressUpdateWithAjax()', 1500);
		}
		
		function abortUpload()
		{
			if (confirm('Are you sure you want to abort the upload? It cannot be resumed.'))
			{
				window.top.frames['progress'].location.href = 'progress.jsp?ID=<%=ID%>&abort=1';
			}
		}
		
		function fileOnChange()
		{
			var frm = document.forms['file'];
			var filename = frm.the_file.value;
			var isZip = false;
			var zipIndex = 0;
			
			for (var i = 0; i < allZipFormats.length; i++)
			{
				var zf = allZipFormats[i];
				if (zf.matchesExtension(filename))
				{
					isZip = true;
					zipIndex = zf.index;
					i = allZipFormats.length;
				}
			}
			
			if (frm.temp_zip_format)
			{
				frm['temp_zip_format'].disabled = !isZip;
				frm['temp_zip_format'].selectedIndex = zipIndex;
				frm['temp_zip_unpack'].disabled = !isZip;
				frm['temp_zip_overwrite'].disabled = !isZip || !frm['temp_zip_unpack'].checked;
				frm['temp_zip_keep'].disabled = !isZip || !frm['temp_zip_unpack'].checked;
				frm['temp_compressed'].disabled = isZip;
				if (isZip)
				{
					// Select '-auto-' if present, otherwise 'no'
					Forms.selectListOption(frm['temp_compressed'], '0');
					Forms.selectListOption(frm['temp_compressed'], '');
				}
			}
		}
		function unpackZipOnClick()
		{
			var frm = document.forms['file'];
			var checked = frm['temp_zip_unpack'].checked;
			if (!checked) frm['temp_zip_keep'].checked = true;
			frm['temp_zip_overwrite'].disabled = !checked;
			frm['temp_zip_keep'].disabled = !checked;
		}
		
		function initZipFormats()
		{
			var frm = document.forms['file'];
			var zipFormat = frm.temp_zip_format;
			if (zipFormat)
			{
			<%
			for (PluginDefinition plugin : plugins)
			{
				FileUnpacker unpacker = plugin.newInstance(FileUnpacker.class, null, sc, null, null);
				%>
					var extensions = [ '<%=Values.getString(unpacker.getExtensions(), "','", true)%>' ];
					var zf = new ZipFormat(zipFormat.length, <%=plugin.getId()%>, '<%=HTML.javaScriptEncode(unpacker.getFormatName())%>', extensions);
					zipFormat[zipFormat.length] = new Option(zf.toString(), zf.id);
				<%
			}
			%>
			}
		}
		
		function displayProgress(fileName, transferredBytes, totalBytes, transferTime, remainTime, unpackMessage)
		{
			// File name
			document.getElementById('fileName').innerHTML = 'Uploading ' + fileName + '...';
				
			// Percent done
			var percentDone = totalBytes == 0 ? 0 : Math.round(100 * transferredBytes / totalBytes);
			document.getElementById('percent').innerHTML = '&nbsp;' + percentDone+'%';
			var doneElement = document.getElementById('percentDone');
			doneElement.style.width = percentDone+'%';
			var remainElement = document.getElementById('percentRemain');
			remainElement.style.width = (100-percentDone)+'%';
			if (percentDone == 100) Main.hide('percentRemain');
			
			// Bytes
			document.getElementById('transferredBytes').innerHTML = Numbers.formatBytes(transferredBytes);
			document.getElementById('totalBytes').innerHTML = Numbers.formatBytes(totalBytes);

			// Times and rate
			var transferRate = transferTime == 0 ? 0 : transferredBytes / transferTime;
			document.getElementById('transferTime').innerHTML = Numbers.formatSeconds(transferTime);
			document.getElementById('transferRate').innerHTML = '(' + Numbers.formatBytes(transferRate) + '/s)';
			document.getElementById('remainTime').innerHTML = Numbers.formatSeconds(remainTime) + ' (estimated)';
			
			// Message
			if (unpackMessage)
			{
				document.getElementById('unpackMessage').innerHTML = unpackMessage.replace(/(.*):(.*)/, '<b>$1:</b> $2');
			}
		}
		
		var allZipFormats = new Array();
		function ZipFormat(index, id, name, extensions)
		{
			this.index = index;
			this.id = id;
			this.name = name;
			this.extensions = extensions;
			
			allZipFormats[allZipFormats.length] = this;
			
			this.matchesExtension = function(filename)
			{
				for (var i = 0; i < this.extensions.length; i++)
				{
					var ext = '.' + this.extensions[i];
					var index = filename.lastIndexOf(ext);
					if (index > 0 && (index + ext.length == filename.length))
					{
						return true;
					}
				}
				return false;
			}
			
			this.toString = function()
			{
				var s = this.name + " [";
				for (var i = 0; i < this.extensions.length; i++)
				{
					if (i > 0) s += ', ';
					s += '*.' + this.extensions[i];
				}
				s += ']';
				return s;
			}
		}
		
		</script>
	</base:head>
	<base:body onload="initZipFormats()">
	<p>
	<div id="selectForm">
		<form action="upload.jsp?ID=<%=ID%>&directory_id=<%=directory.getId()%>" 
			method="post" name="file" enctype="multipart/form-data" onsubmit="return false;" target="upload">

		<input type="hidden" name="check_md5" value="0">
		<input type="hidden" name="write_protected" value="0">
		<input type="hidden" name="replace_existing" value="0">
		<input type="hidden" name="compressed" value="">
		<input type="hidden" name="zip_format" value="">
		<input type="hidden" name="zip_unpack" value="0">
		<input type="hidden" name="zip_overwrite" value="0">
		<input type="hidden" name="zip_keep" value="1">
		<input type="hidden" name="filetype_id" value="">
		<input type="hidden" name="description" value="">
		<input type="hidden" name="characterSet" value="">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*380)+"px;"%>" 
			position="bottom" remember="false">
		<t:tab id="info" title="File" validate="validateFile()" helpid="file.upload">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Directory</td>
				<td><%=HTML.encodeTags(directory.getPath().toString())%></td>
			</tr>
			<tr>
				<td class="prompt">File</td>
				<td>
					<input <%=requiredClazz%> type="file" name="the_file" size="50"
						onchange="fileOnChange()">
				</td>
			</tr>
			<%
			if (file == null)
			{
				%>
				<tr>
					<td class="prompt">Replace existing</td>
					<td>
						<input type="checkbox" name="temp_replace_existing" value="1" >
					</td>
				</tr>
				<%
			}
			 %>
			<tr>
				<td class="prompt">Write protected</td>
				<td>
					<input type="checkbox" name="temp_write_protected" value="1" 
					<%=(file != null && file.isWriteProtected()) || 
						(file == null && Values.getBoolean(cc.getPropertyValue("writeProtected"))) ? "checked" : ""%>>
				</td>
			</tr>
			<tr>
				<td class="prompt">Store compressed</td>
				<td>
					<select name="temp_compressed">
						<%
						if (Application.autoCompressionEnabled())
						{
							%>
							<option value="" <%=compress == null ? "selected" : "" %>>- auto -
							<%
						}
						%>
						<option value="1" <%=Boolean.TRUE.equals(compress) ? "selected" : ""%>>yes
						<option value="0" <%=Boolean.FALSE.equals(compress) ? "selected" : ""%>>no
					</select>
				</td>
			</tr>
			<%
			if (file != null)
			{
				%>
				<tr>
					<td class="prompt">Validate MD5</td>
					<td><input type="checkbox" name="temp_check_md5"></td>
				</tr>
				<%
			}
			%>
			<tr valign="top">
				<td class="prompt">Type</td>
				<td colspan="2">
					<select name="temp_filetype_id" <%=!readCurrentFileType ? "disabled readonly class=\"disabled\"" : ""%>>
					<%
					if (!readCurrentFileType)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						%>
						<option value="0">- none -
						<%
						ItemResultList<FileType> fileTypes = fileTypeQuery.list(dc);
						for (FileType fileType : fileTypes)
						{
							int id = fileType.getId();
							boolean current = id == currentFileTypeId;
							%>
							<option 
								value="<%=current && file != null ? -id : id%>" 
								<%=current ? "selected" : ""%>
								><%=HTML.encodeTags(fileType.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
			</tr>
			<tr>
				<td class="prompt">Character set</td>
				<td>
					<select name="temp_charset">
					<option value="">- n/a -
					<%
					String currentCharset = file == null ? null : file.getCharacterSet();
					boolean hasSelected = false;
					for (String charset : Charset.availableCharsets().keySet())
					{
						boolean selected = charset.equalsIgnoreCase(currentCharset);
						hasSelected |= selected;
						%>
						<option value="<%=charset%>" <%=selected ? "selected" : ""%>><%=charset%>
						<%
					}
					if (!hasSelected && currentCharset != null)
					{
						%>
						<option value="<%=currentCharset%>" selected><%=currentCharset%>
						<%
					}
					%>
					</select>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="50" name="temp_description" wrap="virtual"
						><%=HTML.encodeTags(file == null ? cc.getPropertyValue("description") : file.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'file', 'temp_description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			
			<tr valign=top>
				<td class="prompt">Max trans-<br>fer rate</td>
				<td nowrap>
					<%
					long maxTransferRate = Values.getInt(sc.getClientDefaultSetting("server.transferRate"), 0);
					%>
					<%=maxTransferRate == 0 ? "unlimited" : Values.formatBytes(maxTransferRate)+"/s (approx.)"%>
				</td>
			</tr>
			
			<%
			if (file == null)
			{
				%>
				<tr valign=top>
					<td class="prompt">Compressed file</td>
					<td>
						<select name="temp_zip_format" disabled>
							<option>
						</select><br>
					
						<input type="checkbox" name="temp_zip_unpack" disabled
							onclick="unpackZipOnClick()"><a 
							href="javascript:document.forms['file'].temp_zip_unpack.click()">Unpack file</a><br>
						<input type="checkbox" name="temp_zip_overwrite" disabled
							><a 
							href="javascript:document.forms['file'].temp_zip_overwrite.click()">Overwrite existing files</a><br>
						<input type="checkbox" name="temp_zip_keep" disabled checked
							><a 
							href="javascript:document.forms['file'].temp_zip_keep.click()">Keep the compressed file</a><br>
					</td>
				</tr>
				<%
			}
			%>
			
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>

		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button image="upload.gif" onclick="doUpload()" title="Upload" /></td>
			<td width="50%"><base:button onclick="top.window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</div>
	
	<div id="progressForm" style="display:none;">
		<h3 class="docked" id="fileName">Preparing file upload...</h3>
		<div class="boxed" style="background: #E0E0E0">
			<br>
			<table width="90%" border=0 cellspacing=0 cellpadding=0 align="center">
			<tr>
			<td width="90%" >
				<table width="100%" class="progressbar" border=0 cellspacing=0 cellpadding=0>
				<tr>
					<td width="0%" class="done" id="percentDone">&nbsp;</td>
					<td width="100%" class="remain" id="percentRemain">&nbsp;</td>
				</tr>
				</table>
			</td>
				<td width="10%" id="percent">&nbsp;0%</td>
			</tr>
			<tr>
				<td colspan="2">
					<b>Transferred:</b> <span id="transferredBytes">0 bytes</span> of <span id="totalBytes">unknown</span><br>
					<b>Time:</b> <span id="transferTime">0s</span> <span id="transferRate"></span><br>
					<b>Remain:</b> <span id="remainTime">unknown</span><br>
					<span id="unpackMessage"></span>
				</td>
			</tr>
			</table>
			<br>
		</div>
		<br>
		<table align="center">
		<tr>
			<td><base:button image="cancel.gif" onclick="abortUpload()" title="Abort..." /></td>
		</tr>
		</table>
	
	</div>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
