<%-- $Id: edit_well.jsp 4626 2008-11-05 09:56:12Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hakkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------
	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Well"
	import="net.sf.basedb.core.Plate"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.WELL;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final int plateId = Values.getInt(request.getParameter("plate_id"));
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Well well = Well.getById(dc, itemId);
	Plate plate = well.getPlate();
	ReporterData reporter = well.getReporter();
	
	title = "Edit well -- [" + well.getRow() + ", " + well.getColumn() + "] on plate " + HTML.encodeTags(plate.getName());

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	
	if (well != null && !well.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}

	cc.setObject("item", well);
	%>

	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js" styles="tabcontrol.css">
		<script language="JavaScript">
		// Validate the "Well" tab
		function validateWell()
		{
			var frm = document.forms['well'];
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['well'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				if (inheritedAnnotationsLoaded)
				{
					Annotations.addInheritedAnnotationsToForm(frames.inheritedAnnotations, frm);
				}
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		var inheritedAnnotationsLoaded = false;
		var parentsChanged = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && !annotationsLoaded)
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=well == null ? 0 : well.getId()%>);
					annotationsLoaded = true;
				}
				else if (tabId == 'inheritedAnnotations' && 
					(parentsChanged || !inheritedAnnotationsLoaded))
				{
					Annotations.loadInheritFrame(frames.inheritedAnnotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getParents());
					inheritedAnnotationsLoaded = true;
					parentsChanged = false;
				}
			}
		}
		function getParents()
		{
			return new Array();
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="well" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="plate_id" value="<%=plateId%>">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom" switch="switchTab">
		<t:tab id="info" title="Well" validate="validateWell()" helpid="well.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Plate</td>
				<td><%=HTML.encodeTags(plate.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Coordinate</td>
				<td>[<%=well.getRow()%>, <%=well.getColumn()%>]</td>
			</tr>
			<tr>
				<td class="prompt">Reporter name</td>
				<td><%=reporter == null ? "<i>- none -</i>" : HTML.encodeTags(reporter.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">Reporter External ID</td>
				<td><%=reporter == null ? "<i>- none -</i>" : HTML.encodeTags(reporter.getExternalId())%></td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>

		<t:tab id="annotations" title="Annotations" helpid="annotations.edit">
			<iframe name="annotations" id="idAnnotations" src="../../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		
		<t:tab id="inheritedAnnotations" title="Inherited annotations" helpid="annotations.edit.inherited">
		
			<iframe name="inheritedAnnotations" id="idInheritedAnnotations" src="../../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
