<%-- $Id: view_item.jsp 4511 2008-09-11 20:04:27Z jari $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Removable"
	import="net.sf.basedb.core.Shareable"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemProxy"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Session"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.SharedItem"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.Collections"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>

<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final int itemId = Values.getInt(request.getParameter("item_id"));
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final DbControl dc = sc.newDbControl();
try
{
	BasicItem item = itemType.getById(dc, itemId);
	Set<ItemProxy> usingItems = item.getUsingItems();
	final boolean isUsed = usingItems != null && usingItems.size() > 0;
	final boolean writePermission = item.hasPermission(Permission.WRITE);
	final boolean deletePermission = item.hasPermission(Permission.DELETE);
	final boolean sharePermission = item.hasPermission(Permission.SET_PERMISSION);
	final Shareable shareable = item instanceof Shareable ? (Shareable)item : null;
	final boolean isShared = shareable != null && shareable.isShared();
	final Removable removable = item instanceof Removable ? (Removable)item : null;
	final boolean isRemoved = removable != null && removable.isRemoved();
	String name = "";
	String description = "";
	if (item instanceof File)
	{
		File file = (File)item;
		name = file.getPath().toString();
		description = file.getDescription();
	}
	else if (item instanceof Directory)
	{
		Directory dir = (Directory)item;
		name = dir.getPath().toString();
		description = dir.getDescription();
	}
	else if (item instanceof Nameable)
	{
		Nameable nameable = (Nameable)item;
		name = nameable.getName();
		description = nameable.getDescription();
	}
	else
	{
		name = item.toString();
	}
	String link = Base.getLink(ID, HTML.encodeTags(name), item.getType(), itemId, writePermission);
	%>

	<base:page>
	<base:head scripts="tabcontrol.js,table.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
	<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'usingItems';
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function shareItem()
		{
			var controller = Main.getController('<%=itemType.name()%>');
			var url = getRoot() + controller.url + '?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>';
			Main.openPopup(url, 'ShareItem', 600, 400);
		}
		function restoreItem()
		{
			var controller = Main.getController('<%=itemType.name()%>');
			url = 'index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_type=<%=itemType.name()%>&item_id=<%=itemId%>';			
			url += '&itemsIndexPage=' + getRoot() + controller.url;
			location.replace(url);
		}
		function deleteItem()
		{
			if (!confirm('You are about to PERMANENTLY DELETE this item.\n This can\'t be undone. Continue?'))
			{
				return;
			}
			var url = 'index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_type=<%=itemType.name()%>&item_id=<%=itemId%>';
			location.replace(url);
		}
		function deleteItems()
		{
			var frm = document.forms[formId];
			var numChecked = Forms.numChecked(frm, /item:/);
			if (numChecked == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'DeleteItems';
			frm.submit();
		}
		function restoreItems()
		{
			var frm = document.forms[formId];
			var numChecked = Forms.numChecked(frm, /item:/);
			if (numChecked == 0)
			{
				alert('Please select at least one item in the list');
				return; 
			}
			frm.action = submitPage;
			frm.cmd.value = 'RestoreItems';
			frm.submit();
		}
		function showUsingItems(itemType, itemId)
		{
			var url = 'index.jsp?ID=<%=ID%>&cmd=ViewUsingItems&item_type='+itemType+'&item_id='+itemId;
			location.href = url;
		}
		
	</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Trashcan" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=itemType.toString() + ": " + HTML.encodeTags(name)%>" />
		</p:path>

		<t:tabcontrol id="main">
		<t:tab id="properties" title="Properties">

		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this item" : "You do not have permission to edit this item"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete_permanently.png" : "delete_permanently_disabled.png"%>" 
				onclick="deleteItem()" 
				title="Delete permanently&hellip;"
				visible="<%=!isUsed%>"
				tooltip="<%=deletePermission ? "Permanently delete this item" : "You do not have permission to delete this item"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=isRemoved%>"
				tooltip="<%=writePermission ? "Restore this item" : "You do not have permission to restore this item"%>" 
			/>
			<tbl:button 
				disabled="<%=sharePermission ? false : true%>"
				image="<%=sharePermission ? "share.gif" : "share_disabled.gif"%>"
				onclick="shareItem()" 
				title="Share&hellip;" 
				visible="<%=shareable != null%>"
				tooltip="<%=sharePermission ? "Share this item to other user, groups and projects" : "You do not have permission to share this scan"%>"
			/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'trash.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
		</tbl:toolbar>

		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: 
				<i><%=PermissionUtil.getFullPermissionNames(item)%></i></div>
			<%
			if (isRemoved || isShared || isUsed)
			{
				%>
				<div class="itemstatus">
					<base:icon image="deleted.gif" 
						visible="<%=isRemoved%>" style="margin-bottom: 2px;"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="shared.gif" 
						visible="<%=isShared%>" style="margin-bottom: 2px;"> This item is shared to other user, groups and/or projects<br></base:icon>
					<base:icon image="used.gif" 
						visible="<%=isUsed%>" style="margin-bottom: 2px;"> This item is used by other items and can't be permanently deleted</base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Type</td>
				<td><%=itemType.toString()%></td>
			</tr>
			<tr>
				<td class="prompt">Name</td>
				<td><%=link%></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(description)%></td>
			</tr>
			</table>

			<%
			if (isUsed)
			{
				%>
				<h4 class="docked">Items using <%=itemType.toString()%>: <%=HTML.encodeTags(name)%></h4>
				<tbl:table
					id="usingItems"
					clazz="itemlist"
					columns="all"
				>
				<tbl:hidden 
					name="item_type"
					value="<%=itemType.name()%>"
				/>
				<tbl:hidden 
					name="item_id"
					value="<%=String.valueOf(itemId)%>"
				/>
				<tbl:columndef 
					id="name"
					title="Name/ID"
				/>
				<tbl:columndef
					id="type"
					title="Type"
				/>
				<tbl:columndef 
					id="description"
					title="Description"
				/>
			<tbl:toolbar>
				<tbl:button 
					image="delete.gif"
					onclick="deleteItems()" 
					title="Delete" 
					tooltip="Mark the selected items for deletion" 
				/>
				<tbl:button 
					image="restore.gif"
					onclick="restoreItems()" 
					title="Restore" 
					tooltip="Restore the selected item" 
				/>
			</tbl:toolbar>
				<tbl:data>
					<tbl:columns>
					<tbl:header 
						clazz="index"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="check" 
						><base:icon 
							image="check_uncheck.gif" 
							tooltip="Check/uncheck all" 
							onclick="Forms.checkUncheck(document.forms['usingItems'], /item:/)" style="align: left;"
						/></tbl:header>
					<tbl:header 
						clazz="icons" 
						>&nbsp;</tbl:header>
					</tbl:columns>
					<tbl:rows>
					<%
					int index = 0;
					for (ItemProxy proxy : usingItems)
					{
						index++;
						boolean denied = false;
						boolean writePermissionOnUsedBy = false;
						boolean usedByIsRemoved = false;
						boolean usedByRemovable = false;
						boolean usedByIsUsed = false;
						BasicItem usedBy = null;
						String usedByName = String.valueOf(proxy.getId());
						String usedByDescription = "";
						try
						{
							usedBy = proxy.getItem(dc);
							writePermissionOnUsedBy = usedBy.hasPermission(Permission.WRITE);
							usedByIsUsed = usedBy.isUsed();
							if (usedBy instanceof Removable)
							{
								usedByRemovable = true;
								usedByIsRemoved = ((Removable)usedBy).isRemoved();
							}
							if (usedBy instanceof File)
							{
								File file = (File)usedBy;
								usedByName = file.getPath().toString();
								usedByDescription = file.getDescription();
							}
							else if (usedBy instanceof Directory)
							{
								Directory dir = (Directory)usedBy;
								usedByName = dir.getPath().toString();
								usedByDescription = dir.getDescription();
							}
							else if (usedBy instanceof Nameable)
							{
								Nameable nameable = (Nameable)usedBy;
								usedByName = nameable.getName();
								usedByDescription = nameable.getDescription();
							}
							else
							{
								usedByName = usedBy.toString();
							}
						}
						catch (PermissionDeniedException ex)
						{
							denied = true;
						}
						%>
						<tbl:row>
							<tbl:header 
								clazz="index"
								><%=index%></tbl:header>
							<tbl:header 
								clazz="check"
								><%
								if (usedByRemovable)
								{
									%><input 
										type="checkbox" 
										name="item:<%=proxy.getType().name()%>" 
										value="<%=proxy.getId()%>"
									><%
								}
								%></tbl:header>
							<tbl:header 
								clazz="icons" 
								><base:icon 
									image="deleted.gif" 
									tooltip="This item has been scheduled for deletion" 
									visible="<%=usedByIsRemoved%>"
								/>
								<base:icon 
									image="used.gif"
									tooltip="This item is used by other items"
									visible="<%=usedByIsRemoved &&  usedByIsUsed%>"
									onclick="<%="showUsingItems('" + usedBy.getType().name() + "', " +  usedBy.getId() + ")"%>"
								/>&nbsp;</tbl:header>
							<tbl:cell column="name"><%=Base.getLink(ID, HTML.encodeTags(usedByName), proxy.getType(), proxy.getId(), writePermissionOnUsedBy)%></tbl:cell>
							<tbl:cell column="type"><%=proxy.getType().toString()%></tbl:cell>
							<tbl:cell column="description"><%=HTML.niceFormat(usedByDescription)%></tbl:cell>
						</tbl:row>
						<%
					}
					%>
					</tbl:rows>
				</tbl:data>
				</tbl:table>
				<%
			}
			if (item instanceof SharedItem)
			{
				// Tables with users/groups/projects that this item is shared to
				MultiPermissions mp = new MultiPermissions(Collections.singleton((SharedItem)item));
				ItemResultIterator<User> users = mp.getUsers().iterate(dc);
				ItemResultIterator<Group> groups = mp.getGroups().iterate(dc);
				ItemResultIterator<Project> projects = mp.getProjects().iterate(dc);
				
				if (users.hasNext() || groups.hasNext() || projects.hasNext())
				{
					%>
					<h4 class="docked">Shared to</h4>
					<tbl:table 
						id="itemsSharedTo"
						clazz="itemlist"
						columns="all"
					>
						<tbl:columndef 
							id="itemType"
							title="Item type"
						/>
						<tbl:columndef 
							id="name"
							title="Name"
						/>
						<tbl:columndef 
							id="permissions"
							title="Permissions"
						/>
						<tbl:data>
							<tbl:columns>
							</tbl:columns>
							<tbl:rows>
							<%
							while(projects.hasNext())
							{
								Project project = projects.next();
								Set<Permission> permissions = mp.getPermissions(project).values().iterator().next();
								%>			
								<tbl:row>
									<tbl:cell column="itemType"><%=project.getType()%></tbl:cell>
									<tbl:cell column="name"><%=Base.getLinkedName(ID, project, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%
							}
							while(groups.hasNext())
							{
								Group group = groups.next();
								Set<Permission> permissions = mp.getPermissions(group).values().iterator().next();
								%>
								<tbl:row>							
									<tbl:cell column="itemType"><%=group.getType()%></tbl:cell>
									<tbl:cell column="name"><%=Base.getLinkedName(ID, group, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%	
							}
							while (users.hasNext())
							{
								User user = users.next();
								Set<Permission> permissions = mp.getPermissions(user).values().iterator().next();
								%>
								<tbl:row>							
									<tbl:cell column="itemType"><%=user.getType()%></tbl:cell>
									<tbl:cell column="name"><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
					<%
				}
				else
				{
					%>
					<h4>Shared to</h4>
					This <%=itemType %> is not shared 
					(or, you don't have permission to view the ones it is shared to).
					<%
				}
			}
			%>

		</t:tab>
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.commit();
}

%>
